from binary_file import write_byte_array, read_byte_array, print_bin_file

# Matici reprezentujeme jako pole polí:
# [[0, 1], [2, 3]]
#
# Rozsah hodnot je od 0 do 255 (jeden bajt).

# Uloží matici do souboru.
def store_matrix(file_name, matrix):
    with open(file_name, 'bw') as file:
        for row in matrix:
            write_byte_array(file, row)
        
""""
>>> store_matrix('matrix.b', [[0, 1], [2, 3]])
>>> print_bin_file('matrix.b')
00000000 00000001 00000010 00000011 
>>> store_matrix('matrix.b', [[-4, 1], [2, 3]])
ValueError: bytes must be in range(0, 256)
>>> store_matrix('matrix.b', [[300, 1], [2, 3]])
ValueError: bytes must be in range(0, 256)
"""
SIZE = 2
# Načte matici ze souboru.
def load_matrix(file_name):
    matrix = []
    with open(file_name, 'br') as file:
        for i in range(SIZE):
            row = read_byte_array(file, SIZE)
            matrix += [row]
    return matrix

"""
>>> load_matrix('matrix.b')
[[0, 1], [2, 3]]
"""
# Načte ze souboru buňku na řádku i v sloupci j.
def load_cell(file_name, i, j):
    with open(file_name, 'br') as file:
        position = i * SIZE + j
        file.seek(position)
        byte_array = read_byte_array(file, 1)
        cell = byte_array[0]
        return cell        
        
"""
>>> load_cell('matrix.b', 1, 1)
3
"""

# Nastaví v souboru buňku na řádku i v sloupci j na zadanou hodnotu.
"""
>>> store_cell('matrix.b', 1, 1, 0)
>>> load_cell('matrix.b', 1, 1)
0
"""
# V matici nahradí všechny výskyty jedné hodnoty za druhou.
# (Bez načtení celé matice do paměti.)
def replace_cell(file_name, cell1, cell2):
    with open(file_name, 'br+') as file:
        for i in range(SIZE):
            for j in range(SIZE):
                byte_array = read_byte_array(file, 1)
                cell = byte_array[0]
                if cell == cell1:
                    position = file.tell()
                    file.seek(position - 1)
                    write_byte_array(file, [cell2])
                    

"""
>>> load_matrix('matrix.b')
[[0, 1], [2, 0]]
>>> replace_cell('matrix.b', 0, 5)
>>> load_matrix('matrix.b')
[[5, 1], [2, 5]]
"""

                
        
"""
>>> transpose_matrix("matrix.b")
>>> load_matrix('matrix.b')
[[5, 2], [1, 5]]
"""
