from binary_file import write_byte_array, read_byte_array, print_bin_file

# První bajt uchovává počet řádků a druhý počet sloupců.

# Uloží matici do souboru.
def store_matrix(file_name, matrix):
    with open(file_name, 'bw') as file:
        write_byte_array(file, [len(matrix), len(matrix[0])])
        for row in matrix:
            write_byte_array(file, row)


""""
>>> store_matrix('matrix.b', [[0, 1, 2], [3, 4, 5]])
>>> print_bin_file('matrix.b')
00000010 00000011 00000000 00000001 00000010 00000011 
00000100 00000101 
"""   

# Načte matici ze souboru.
def load_matrix(file_name):
    matrix = []
    with open(file_name, 'br') as file:
        size = read_byte_array(file, 2)
        rows_count = size[0]
        columns_count = size[1]
        for i in range(rows_count):
            row = read_byte_array(file, columns_count)
            matrix += [row]
    return matrix

"""
>>> load_matrix('matrix.b')
[[0, 1, 2], [3, 4, 5]]
"""
